exception Parse_Error;;
type token = Int of int | PLUS | Eof;;
let descente gettoken = 
 let position = ref 1 and tok = ref (gettoken()) in
 let advance () = tok := gettoken(); position := !position+1 in
 let eat t = if (!tok = t) then advance() else raise Parse_Error in
 let check t = if (!tok = t) then () else raise Parse_Error
 in
 let rec ntS () = (let e = ntE() in (check(Eof);e))
 and ntE () = match !tok with  Int(n) -> (advance(); ntE'(n))
                         |  _   -> raise Parse_Error
 and ntE'(v) = match !tok with PLUS -> (eat(PLUS);
                                        match !tok with 
                                            Int(n) -> advance(); ntE'(v+n)
                                        |  _       -> raise Parse_Error
                                       )
                         |  _      -> (v) (* transition vide *)
in ntS();;

(* un lexeur bidon vite fait *)
let gettoken_of l = let data = ref l in
    let f () = let t = List.hd !data in data:= List.tl !data; t in f;;

descente (gettoken_of [Int(3);PLUS;Int(2);PLUS;Int(5);Eof]);;
